// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDS3DListener.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDS3DListener Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDS3DListener.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDS3DListener*)
{
    new TDS3DListener(NULL);
}
// --------------------------------------------------------------------------
namespace Tds3dlistener
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDS3DListener)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDS3DListener::TDS3DListener()
// Description: The default constructor for the TDS3DListener object.
// --------------------------------------------------------------------------
__fastcall TDS3DListener::TDS3DListener(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDS3DListener::~TDS3DListener()
// Description: The destructor for the TDS3DListener object.
// --------------------------------------------------------------------------
__fastcall TDS3DListener::~TDS3DListener()
{
}
// --------------------------------------------------------------------------
// Property:    DistanceFactor
// Description: The DistanceFactor property defines a D3DVALUE representing 
//              the current distance factor for the listener. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TDS3DListener::FGetDistanceFactor()
{
return fDS3DLISTENER.flDistanceFactor;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetDistanceFactor( D3DVALUE pDistanceFactor )
{
fDS3DLISTENER.flDistanceFactor = pDistanceFactor;
}
// --------------------------------------------------------------------------
// Property:    DopplerFactor
// Description: The DopplerFactor property defines a D3DVALUE representing 
//              the current doppler shift factor for the listener. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TDS3DListener::FGetDopplerFactor()
{
return fDS3DLISTENER.flDopplerFactor;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetDopplerFactor( D3DVALUE pDopplerFactor )
{
fDS3DLISTENER.flDopplerFactor = pDopplerFactor;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDS3DListener method or fget/fset. 
//              eg. DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDS3DListener::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    OrientFront
// Description: The OrientFront property defines a D3DVECTOR indicating the 
//              listener's front orientation. 
// --------------------------------------------------------------------------
D3DVECTOR __fastcall TDS3DListener::FGetOrientFront()
{
return fDS3DLISTENER.vOrientFront;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetOrientFront( D3DVECTOR pOrientFront )
{
fDS3DLISTENER.vOrientFront = pOrientFront;
}
// --------------------------------------------------------------------------
// Property:    OrientTop
// Description: The OrientTop property defines a D3DVECTOR indicating the 
//              listener's top orientation. 
// --------------------------------------------------------------------------
D3DVECTOR __fastcall TDS3DListener::FGetOrientTop()
{
return fDS3DLISTENER.vOrientTop;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetOrientTop( D3DVECTOR pOrientTop )
{
fDS3DLISTENER.vOrientTop = pOrientTop;
}
// --------------------------------------------------------------------------
// Property:    Position
// Description: The Position property defines a D3DVECTOR which describes the 
//              listener's position in 3D space. 
// --------------------------------------------------------------------------
D3DVECTOR __fastcall TDS3DListener::FGetPosition()
{
return fDS3DLISTENER.vPosition;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetPosition( D3DVECTOR pPosition )
{
fDS3DLISTENER.vPosition = pPosition;
}
// --------------------------------------------------------------------------
// Property:    RolloffFactor
// Description: The RolloffFactor property defines a D3DVALUE representing 
//              the current rolloff factor for the listener. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TDS3DListener::FGetRolloffFactor()
{
return fDS3DLISTENER.flRolloffFactor;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetRolloffFactor( D3DVALUE pRolloffFactor )
{
fDS3DLISTENER.flRolloffFactor = pRolloffFactor;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDS3DListener::FGetSize()
{
return fDS3DLISTENER.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetSize( dword pSize )
{
fDS3DLISTENER.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Velocity
// Description: The Velocity property defines a D3DVECTOR representing the 
//              listener's velocity in 3D space. 
//              The value of this property is independent of the actual 
//              position and movement of a listener, the application is 
//              responsible for setting the appropriate velocity value. 
// --------------------------------------------------------------------------
D3DVECTOR __fastcall TDS3DListener::FGetVelocity()
{
return fDS3DLISTENER.vVelocity;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetVelocity( D3DVECTOR pVelocity )
{
fDS3DLISTENER.vVelocity = pVelocity;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDS3DListener's internal DS3DLISTENER structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::Clear()
{
fErrorValue = DS_OK;
fDS3DLISTENER.dwSize = sizeof(DS3DLISTENER);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DS3DLISTENER* __fastcall TDS3DListener::FGetInternal_DS3DLISTENER_Ptr()
{
return &fDS3DLISTENER;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::FSetInternal_DS3DLISTENER( DS3DLISTENER* pDS3DLISTENER )
{
if (pDS3DLISTENER==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDS3DListener::FSetInternal_DS3DLISTENER()", "TDX_ERROR", "The supplied DS3DLISTENER* was NULL" );
    return;
    }

CopyMemory( &fDS3DLISTENER, pDS3DLISTENER, sizeof(DS3DLISTENER) );
Internal_DS3DLISTENER_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDS3DListener::Internal_DS3DLISTENER_Update()
{
}

// --------------------------------------------------------------------------
