// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDSBCaps.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDSBCaps Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDSBCaps.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDSBCaps*)
{
    new TDSBCaps(NULL);
}
// --------------------------------------------------------------------------
namespace Tdsbcaps
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDSBCaps)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDSBCaps::TDSBCaps()
// Description: The default constructor for the TDSBCaps object.
// --------------------------------------------------------------------------
__fastcall TDSBCaps::TDSBCaps(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDSBCaps::~TDSBCaps()
// Description: The destructor for the TDSBCaps object.
// --------------------------------------------------------------------------
__fastcall TDSBCaps::~TDSBCaps()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    BufferBytes
// Description: The BufferBytes property defines the size, in bytes, of the 
//              buffer. 
// --------------------------------------------------------------------------
dword __fastcall TDSBCaps::FGetBufferBytes()
{
return fDSBCAPS.dwBufferBytes;
}
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::FSetBufferBytes( dword pBufferBytes )
{
fDSBCAPS.dwBufferBytes = pBufferBytes;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDSBCaps method or fget/fset. eg. 
//              DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDSBCaps::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags specifying the capabilities 
//              of the sound buffer. 
//              The described effect applies when the flag is set. 
//              
//              For optimum performance only specify control options that 
//              will be used. 
//              Attempts to use a control that is not set on a buffer will 
//              result in the method failing. 
// Flags:       DSBCAPS_CTRL3D -
//                The buffer is a primary or 3D secondary buffer. 
//                For this to be a primary buffer, DSBCAPS_PRIMARYBUFFER 
//                should be set in TDSBufferDesc::Flags. 
//              DSBCAPS_CTRLFREQUENCY -
//                The buffer has frequency control capability. 
//                Frequency Control control is the ability to modify the 
//                frequency, in samples per second, at which the buffer is 
//                playing. 
//              DSBCAPS_CTRLPAN -
//                The buffer has pan control capability. 
//                Pan control is the ability to modify the relative values of 
//                the left and right audio channels. 
//              DSBCAPS_CTRLPOSITIONNOTIFY -
//                The buffer has position notification capability. 
//                
//                Position notification is the ability to set triggers, which 
//                activate specified events, on reaching certain positions or 
//                conditions within a sound buffer. 
//                
//                Setting DSBCAPS_CTRLPOSITIONNOTIFY when the hardware uses 
//                VxD drivers forces the buffer to be a software buffer. 
//                VxD drivers don't support the notifications. 
//                
//                WDM drivers do support notifications so the buffer may be 
//                located in hardware memory if available. 
//                
//                Calling TDx_SoundBuffer::Play() with DSBPLAY_LOCHARDWARE 
//                will fail if this flag is set. 
//              DSBCAPS_CTRLVOLUME -
//                The buffer has volume control capability. 
//                Volume control is the ability to modify the volume of a 
//                sound buffer. 
//              DSBCAPS_GETCURRENTPOSITION2 -
//                TDx_SoundBuffer::GetCurrentPosition() uses the new behavior 
//                of the play cursor and thus return a much more accurate 
//                position. 
//                
//                This flag should always be set unless compatability with 
//                DirectX 1 is required. 
//                This flag only affects emulated sound cards. 
//              DSBCAPS_GLOBALFOCUS -
//                The buffer is a global sound buffer. 
//                Global sound buffers will continue to play even when the 
//                focus is switched to another application, unless that 
//                application is utilizing the DSSCL_EXCLUSIVE or 
//                DSSCL_WRITEPRIMARY cooperative levels. 
//              DSBCAPS_LOCDEFER -
//                The location of the buffer in hardware or software memory 
//                can be decided when the buffer is played. 
//              DSBCAPS_LOCHARDWARE -
//                The buffer is located in hardware memory and uses hardware 
//                mixing. 
//              DSBCAPS_LOCSOFTWARE -
//                The buffer is located in software memory and uses software 
//                mixing. 
//              DSBCAPS_MUTE3DATMAXDISTANCE -
//                The buffer will cease playing when its maximum distance is 
//                exceeded. 
//                This option prevents the wasting of processor time by not 
//                calculating and mixing sounds that are effectively 
//                inaudible. 
//              DSBCAPS_PRIMARYBUFFER -
//                The buffer is a primary sound buffer. 
//              DSBCAPS_STATIC -
//                The buffer will be used for static sound data. 
//                A sound buffer without this flag set will be a streaming 
//                sound buffer. 
//              DSBCAPS_STICKYFOCUS -
//                The buffer has a sticky focus. 
//                Having a sticky focus means that an application will 
//                continue to play any sticky focus buffers it has when the 
//                user switches to another application, as long as the new 
//                focus application doesnt utilize DirectSound. 
// --------------------------------------------------------------------------
dword __fastcall TDSBCaps::FGetFlags()
{
return fDSBCAPS.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::FSetFlags( dword pFlags )
{
fDSBCAPS.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    PlayCpuOverhead
// Description: The PlayCpuOverhead property represents the percentage of 
//              main processing cycles needed to mix this sound buffer. 
//              For a hardware buffer the value will be 0, for a software 
//              buffer, the value will depend on the buffer's format and the 
//              speed of the system processor. 
// --------------------------------------------------------------------------
dword __fastcall TDSBCaps::FGetPlayCpuOverhead()
{
return fDSBCAPS.dwPlayCpuOverhead;
}
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::FSetPlayCpuOverhead( dword pPlayCpuOverhead )
{
fDSBCAPS.dwPlayCpuOverhead = pPlayCpuOverhead;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDSBCaps::FGetSize()
{
return fDSBCAPS.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::FSetSize( dword pSize )
{
fDSBCAPS.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    UnlockTransferRate
// Description: The UnlockTransferRate property describes the rate at which 
//              data is transferred, in kilobytes per second, to buffer 
//              memory when TDx_SoundBuffer::Unlock() is called. 
//              
//              This value, along with the number of bytes, can be used by 
//              applications to determine the time required for the Unlock to 
//              execute. 
//              Software buffers located in system memory will have a very 
//              high rate because no processing is required. 
//              Hardware buffers may have a slower rate because the buffer 
//              might have to be downloaded to the sound card. 
// --------------------------------------------------------------------------
dword __fastcall TDSBCaps::FGetUnlockTransferRate()
{
return fDSBCAPS.dwUnlockTransferRate;
}
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::FSetUnlockTransferRate( dword pUnlockTransferRate )
{
fDSBCAPS.dwUnlockTransferRate = pUnlockTransferRate;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDSBCaps's internal DSBCAPS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::Clear()
{
fDSBCAPS.dwBufferBytes = 0;
fErrorValue = DS_OK;
fDSBCAPS.dwFlags = 0;
fDSBCAPS.dwPlayCpuOverhead = 0;
fDSBCAPS.dwSize = sizeof(DSBCAPS);
fDSBCAPS.dwUnlockTransferRate = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DSBCAPS* __fastcall TDSBCaps::FGetInternal_DSBCAPS_Ptr()
{
return &fDSBCAPS;
}
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::FSetInternal_DSBCAPS( DSBCAPS* pDSBCAPS )
{
if (pDSBCAPS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDSBCaps::FSetInternal_DSBCAPS()", "TDX_ERROR", "The supplied DSBCAPS* was NULL" );
    return;
    }

CopyMemory( &fDSBCAPS, pDSBCAPS, sizeof(DSBCAPS) );
Internal_DSBCAPS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::Internal_DSBCAPS_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDSBCaps_Flags_Set<> of the flags in 
//              the current fDSBCAPS.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDSBCaps_Flags_Set __fastcall TDSBCaps::FGetFlags_()
{
TDSBCaps_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDSBCAPS.dwFlags & DSBCAPS_CTRL3D) TempFlags_ = TempFlags_ << dsbcaps_ctrl3d;
if (fDSBCAPS.dwFlags & DSBCAPS_CTRLFREQUENCY) TempFlags_ = TempFlags_ << dsbcaps_ctrlfrequency_;
if (fDSBCAPS.dwFlags & DSBCAPS_CTRLPAN) TempFlags_ = TempFlags_ << dsbcaps_ctrlpan;
if (fDSBCAPS.dwFlags & DSBCAPS_CTRLPOSITIONNOTIFY) TempFlags_ = TempFlags_ << dsbcaps_ctrlpositionnotify;
if (fDSBCAPS.dwFlags & DSBCAPS_CTRLVOLUME) TempFlags_ = TempFlags_ << dsbcaps_ctrlvolume_;
if (fDSBCAPS.dwFlags & DSBCAPS_GETCURRENTPOSITION2) TempFlags_ = TempFlags_ << dsbcaps_getcurrentposition2;
if (fDSBCAPS.dwFlags & DSBCAPS_GLOBALFOCUS) TempFlags_ = TempFlags_ << dsbcaps_globalfocus_;
if (fDSBCAPS.dwFlags & DSBCAPS_LOCDEFER) TempFlags_ = TempFlags_ << dsbcaps_locdefer_;
if (fDSBCAPS.dwFlags & DSBCAPS_LOCHARDWARE) TempFlags_ = TempFlags_ << dsbcaps_lochardware_;
if (fDSBCAPS.dwFlags & DSBCAPS_LOCSOFTWARE) TempFlags_ = TempFlags_ << dsbcaps_locsoftware;
if (fDSBCAPS.dwFlags & DSBCAPS_MUTE3DATMAXDISTANCE) TempFlags_ = TempFlags_ << dsbcaps_mute3datmaxdistance;
if (fDSBCAPS.dwFlags & DSBCAPS_PRIMARYBUFFER) TempFlags_ = TempFlags_ << dsbcaps_primarybuffer;
if (fDSBCAPS.dwFlags & DSBCAPS_STATIC) TempFlags_ = TempFlags_ << dsbcaps_static_;
if (fDSBCAPS.dwFlags & DSBCAPS_STICKYFOCUS) TempFlags_ = TempFlags_ << dsbcaps_stickyfocus_;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDSBCaps::FSetFlags_( TDSBCaps_Flags_Set pFlags_ )
{
fDSBCAPS.dwFlags = 0;
if (pFlags_.Contains(dsbcaps_ctrl3d)) fDSBCAPS.dwFlags |= DSBCAPS_CTRL3D;
if (pFlags_.Contains(dsbcaps_ctrlfrequency_)) fDSBCAPS.dwFlags |= DSBCAPS_CTRLFREQUENCY;
if (pFlags_.Contains(dsbcaps_ctrlpan)) fDSBCAPS.dwFlags |= DSBCAPS_CTRLPAN;
if (pFlags_.Contains(dsbcaps_ctrlpositionnotify)) fDSBCAPS.dwFlags |= DSBCAPS_CTRLPOSITIONNOTIFY;
if (pFlags_.Contains(dsbcaps_ctrlvolume_)) fDSBCAPS.dwFlags |= DSBCAPS_CTRLVOLUME;
if (pFlags_.Contains(dsbcaps_getcurrentposition2)) fDSBCAPS.dwFlags |= DSBCAPS_GETCURRENTPOSITION2;
if (pFlags_.Contains(dsbcaps_globalfocus_)) fDSBCAPS.dwFlags |= DSBCAPS_GLOBALFOCUS;
if (pFlags_.Contains(dsbcaps_locdefer_)) fDSBCAPS.dwFlags |= DSBCAPS_LOCDEFER;
if (pFlags_.Contains(dsbcaps_lochardware_)) fDSBCAPS.dwFlags |= DSBCAPS_LOCHARDWARE;
if (pFlags_.Contains(dsbcaps_locsoftware)) fDSBCAPS.dwFlags |= DSBCAPS_LOCSOFTWARE;
if (pFlags_.Contains(dsbcaps_mute3datmaxdistance)) fDSBCAPS.dwFlags |= DSBCAPS_MUTE3DATMAXDISTANCE;
if (pFlags_.Contains(dsbcaps_primarybuffer)) fDSBCAPS.dwFlags |= DSBCAPS_PRIMARYBUFFER;
if (pFlags_.Contains(dsbcaps_static_)) fDSBCAPS.dwFlags |= DSBCAPS_STATIC;
if (pFlags_.Contains(dsbcaps_stickyfocus_)) fDSBCAPS.dwFlags |= DSBCAPS_STICKYFOCUS;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDSBCaps::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDSBCaps::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDSBCAPS.dwFlags & DSBCAPS_CTRL3D) fFlags_Strings->Add("DSBCAPS_CTRL3D");
if (fDSBCAPS.dwFlags & DSBCAPS_CTRLFREQUENCY) fFlags_Strings->Add("DSBCAPS_CTRLFREQUENCY");
if (fDSBCAPS.dwFlags & DSBCAPS_CTRLPAN) fFlags_Strings->Add("DSBCAPS_CTRLPAN");
if (fDSBCAPS.dwFlags & DSBCAPS_CTRLPOSITIONNOTIFY) fFlags_Strings->Add("DSBCAPS_CTRLPOSITIONNOTIFY");
if (fDSBCAPS.dwFlags & DSBCAPS_CTRLVOLUME) fFlags_Strings->Add("DSBCAPS_CTRLVOLUME");
if (fDSBCAPS.dwFlags & DSBCAPS_GETCURRENTPOSITION2) fFlags_Strings->Add("DSBCAPS_GETCURRENTPOSITION2");
if (fDSBCAPS.dwFlags & DSBCAPS_GLOBALFOCUS) fFlags_Strings->Add("DSBCAPS_GLOBALFOCUS");
if (fDSBCAPS.dwFlags & DSBCAPS_LOCDEFER) fFlags_Strings->Add("DSBCAPS_LOCDEFER");
if (fDSBCAPS.dwFlags & DSBCAPS_LOCHARDWARE) fFlags_Strings->Add("DSBCAPS_LOCHARDWARE");
if (fDSBCAPS.dwFlags & DSBCAPS_LOCSOFTWARE) fFlags_Strings->Add("DSBCAPS_LOCSOFTWARE");
if (fDSBCAPS.dwFlags & DSBCAPS_MUTE3DATMAXDISTANCE) fFlags_Strings->Add("DSBCAPS_MUTE3DATMAXDISTANCE");
if (fDSBCAPS.dwFlags & DSBCAPS_PRIMARYBUFFER) fFlags_Strings->Add("DSBCAPS_PRIMARYBUFFER");
if (fDSBCAPS.dwFlags & DSBCAPS_STATIC) fFlags_Strings->Add("DSBCAPS_STATIC");
if (fDSBCAPS.dwFlags & DSBCAPS_STICKYFOCUS) fFlags_Strings->Add("DSBCAPS_STICKYFOCUS");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
