// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDSCBCaps.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDSCBCaps Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDSCBCaps.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDSCBCaps*)
{
    new TDSCBCaps(NULL);
}
// --------------------------------------------------------------------------
namespace Tdscbcaps
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDSCBCaps)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDSCBCaps::TDSCBCaps()
// Description: The default constructor for the TDSCBCaps object.
// --------------------------------------------------------------------------
__fastcall TDSCBCaps::TDSCBCaps(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDSCBCaps::~TDSCBCaps()
// Description: The destructor for the TDSCBCaps object.
// --------------------------------------------------------------------------
__fastcall TDSCBCaps::~TDSCBCaps()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    BufferBytes
// Description: The BufferBytes property defines the size, in bytes, of the 
//              capture buffer. 
// --------------------------------------------------------------------------
dword __fastcall TDSCBCaps::FGetBufferBytes()
{
return fDSCBCAPS.dwBufferBytes;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBCaps::FSetBufferBytes( dword pBufferBytes )
{
fDSCBCAPS.dwBufferBytes = pBufferBytes;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDSCBCaps method or fget/fset. eg. 
//              DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDSCBCaps::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBCaps::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines a flag indicating capture buffer 
//              capabilities. 
//              The described effect applies when the flag is set. 
// Flags:       DSCBCAPS_WAVEMAPPED -
//                Unsupported formats will use the Win32 wave mapper. 
// --------------------------------------------------------------------------
dword __fastcall TDSCBCaps::FGetFlags()
{
return fDSCBCAPS.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBCaps::FSetFlags( dword pFlags )
{
fDSCBCAPS.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDSCBCaps::FGetSize()
{
return fDSCBCAPS.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBCaps::FSetSize( dword pSize )
{
fDSCBCAPS.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDSCBCaps's internal DSCBCAPS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDSCBCaps::Clear()
{
fDSCBCAPS.dwBufferBytes = 0;
fErrorValue = DS_OK;
fDSCBCAPS.dwFlags = 0;
fDSCBCAPS.dwSize = sizeof(DSCBCAPS);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DSCBCAPS* __fastcall TDSCBCaps::FGetInternal_DSCBCAPS_Ptr()
{
return &fDSCBCAPS;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBCaps::FSetInternal_DSCBCAPS( DSCBCAPS* pDSCBCAPS )
{
if (pDSCBCAPS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDSCBCaps::FSetInternal_DSCBCAPS()", "TDX_ERROR", "The supplied DSCBCAPS* was NULL" );
    return;
    }

CopyMemory( &fDSCBCAPS, pDSCBCAPS, sizeof(DSCBCAPS) );
Internal_DSCBCAPS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDSCBCaps::Internal_DSCBCAPS_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDSCBCaps_Flags_Set<> of the flags in 
//              the current fDSCBCAPS.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDSCBCaps_Flags_Set __fastcall TDSCBCaps::FGetFlags_()
{
TDSCBCaps_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDSCBCAPS.dwFlags & DSCBCAPS_WAVEMAPPED) TempFlags_ = TempFlags_ << dscbcaps_wavemapped_;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBCaps::FSetFlags_( TDSCBCaps_Flags_Set pFlags_ )
{
fDSCBCAPS.dwFlags = 0;
if (pFlags_.Contains(dscbcaps_wavemapped_)) fDSCBCAPS.dwFlags |= DSCBCAPS_WAVEMAPPED;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDSCBCaps::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDSCBCaps::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDSCBCAPS.dwFlags & DSCBCAPS_WAVEMAPPED) fFlags_Strings->Add("DSCBCAPS_WAVEMAPPED");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
