// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDSCCaps.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDSCCaps Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDSCCaps.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDSCCaps*)
{
    new TDSCCaps(NULL);
}
// --------------------------------------------------------------------------
namespace Tdsccaps
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDSCCaps)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDSCCaps::TDSCCaps()
// Description: The default constructor for the TDSCCaps object.
// --------------------------------------------------------------------------
__fastcall TDSCCaps::TDSCCaps(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
fFormats_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDSCCaps::~TDSCCaps()
// Description: The destructor for the TDSCCaps object.
// --------------------------------------------------------------------------
__fastcall TDSCCaps::~TDSCCaps()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
if (fFormats_Strings!=NULL) delete fFormats_Strings;
}
// --------------------------------------------------------------------------
// Property:    Channels
// Description: The Channels property defines the number of channels the 
//              device supports. 
//              1 is mono, 2 is stereo, etc. 
// --------------------------------------------------------------------------
dword __fastcall TDSCCaps::FGetChannels()
{
return fDSCCAPS.dwChannels;
}
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::FSetChannels( dword pChannels )
{
fDSCCAPS.dwChannels = pChannels;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDSCCaps method or fget/fset. eg. 
//              DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDSCCaps::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags specifying the available 
//              hardware capture buffer capabilities. 
//              The described effect applies when the flag is set. 
// Flags:       DSCAPS_CERTIFIED -
//                The wave demodulation driver has been tested and certified 
//                by Microsoft. 
//              DSCCAPS_EMULDRIVER -
//                There is no DirectSoundCapture driver installed for this 
//                device, so it is being emulated using the standard Windows 
//                waveform-audio functions. 
//                Expect some degree of performance degradation. 
// --------------------------------------------------------------------------
dword __fastcall TDSCCaps::FGetFlags()
{
return fDSCCAPS.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::FSetFlags( dword pFlags )
{
fDSCCAPS.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    Formats
// Description: The Formats property defines flags indicating the standard 
//              wave formats that are supported. 
//              These formats are the same as those used by the WAVEINCAPS 
//              structure utilized in the Win32 waveform audio functions. 
// Flags:       WAVE_FORMAT_1M08 -
//                Wave formats that are 11.025 kHz, mono and 8-bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_1M16 -
//                Wave formats that are 11.025 kHz, mono and 16 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_1S08 -
//                Wave formats that are 11.025 kHz, stereo and 8 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_1S16 -
//                Wave formats that are 11.025 kHz, stereo and 16 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_2M08 -
//                Wave formats that are 22.05 kHz, mono and 8 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_2M16 -
//                Wave formats that are 22.05 kHz, mono and 16 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_2S08 -
//                Wave formats that are 22.05 kHz, stereo and 8 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_2S16 -
//                Wave formats that are 22.05 kHz, stereo and 16 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_4M08 -
//                Wave formats that are 44.1 kHz, mono and 8 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_4M16 -
//                Wave formats that are 44.1 kHz, mono and 16 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_4S08 -
//                Wave formats that are 44.1 kHz, stereo and 8 bit are 
//                supported by the hardware. 
//              WAVE_FORMAT_4S16 -
//                Wave formats that are 44.1 kHz, stereo and 16 bit are 
//                supported by the hardware. 
// --------------------------------------------------------------------------
dword __fastcall TDSCCaps::FGetFormats()
{
return fDSCCAPS.dwFormats;
}
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::FSetFormats( dword pFormats )
{
fDSCCAPS.dwFormats = pFormats;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDSCCaps::FGetSize()
{
return fDSCCAPS.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::FSetSize( dword pSize )
{
fDSCCAPS.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDSCCaps's internal DSCCAPS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::Clear()
{
fDSCCAPS.dwChannels = 0;
fErrorValue = DS_OK;
fDSCCAPS.dwFlags = 0;
fDSCCAPS.dwFormats = 0;
fDSCCAPS.dwSize = sizeof(DSCCAPS);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DSCCAPS* __fastcall TDSCCaps::FGetInternal_DSCCAPS_Ptr()
{
return &fDSCCAPS;
}
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::FSetInternal_DSCCAPS( DSCCAPS* pDSCCAPS )
{
if (pDSCCAPS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDSCCaps::FSetInternal_DSCCAPS()", "TDX_ERROR", "The supplied DSCCAPS* was NULL" );
    return;
    }

CopyMemory( &fDSCCAPS, pDSCCAPS, sizeof(DSCCAPS) );
Internal_DSCCAPS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::Internal_DSCCAPS_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDSCCaps_Flags_Set<> of the flags in 
//              the current fDSCCAPS.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDSCCaps_Flags_Set __fastcall TDSCCaps::FGetFlags_()
{
TDSCCaps_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDSCCAPS.dwFlags & DSCAPS_CERTIFIED) TempFlags_ = TempFlags_ << dscaps_certified;
if (fDSCCAPS.dwFlags & DSCCAPS_EMULDRIVER) TempFlags_ = TempFlags_ << dsccaps_emuldriver;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::FSetFlags_( TDSCCaps_Flags_Set pFlags_ )
{
fDSCCAPS.dwFlags = 0;
if (pFlags_.Contains(dscaps_certified)) fDSCCAPS.dwFlags |= DSCAPS_CERTIFIED;
if (pFlags_.Contains(dsccaps_emuldriver)) fDSCCAPS.dwFlags |= DSCCAPS_EMULDRIVER;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDSCCaps::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDSCCaps::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDSCCAPS.dwFlags & DSCAPS_CERTIFIED) fFlags_Strings->Add("DSCAPS_CERTIFIED");
if (fDSCCAPS.dwFlags & DSCCAPS_EMULDRIVER) fFlags_Strings->Add("DSCCAPS_EMULDRIVER");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetFormats_
// Description: This method returns a TDSCCaps_Formats_Set<> of the flags in 
//              the current fDSCCAPS.dwFormats. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDSCCaps_Formats_Set __fastcall TDSCCaps::FGetFormats_()
{
TDSCCaps_Formats_Set TempFormats_;
TempFormats_.Clear();
if (fDSCCAPS.dwFormats & WAVE_FORMAT_1M08) TempFormats_ = TempFormats_ << wave_format_1m08;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_1M16) TempFormats_ = TempFormats_ << wave_format_1m16;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_1S08) TempFormats_ = TempFormats_ << wave_format_1s08;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_1S16) TempFormats_ = TempFormats_ << wave_format_1s16;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_2M08) TempFormats_ = TempFormats_ << wave_format_2m08;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_2M16) TempFormats_ = TempFormats_ << wave_format_2m16;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_2S08) TempFormats_ = TempFormats_ << wave_format_2s08;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_2S16) TempFormats_ = TempFormats_ << wave_format_2s16;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_4M08) TempFormats_ = TempFormats_ << wave_format_4m08;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_4M16) TempFormats_ = TempFormats_ << wave_format_4m16;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_4S08) TempFormats_ = TempFormats_ << wave_format_4s08;
if (fDSCCAPS.dwFormats & WAVE_FORMAT_4S16) TempFormats_ = TempFormats_ << wave_format_4s16;
return TempFormats_;
}
// --------------------------------------------------------------------------
void __fastcall TDSCCaps::FSetFormats_( TDSCCaps_Formats_Set pFormats_ )
{
fDSCCAPS.dwFormats = 0;
if (pFormats_.Contains(wave_format_1m08)) fDSCCAPS.dwFormats |= WAVE_FORMAT_1M08;
if (pFormats_.Contains(wave_format_1m16)) fDSCCAPS.dwFormats |= WAVE_FORMAT_1M16;
if (pFormats_.Contains(wave_format_1s08)) fDSCCAPS.dwFormats |= WAVE_FORMAT_1S08;
if (pFormats_.Contains(wave_format_1s16)) fDSCCAPS.dwFormats |= WAVE_FORMAT_1S16;
if (pFormats_.Contains(wave_format_2m08)) fDSCCAPS.dwFormats |= WAVE_FORMAT_2M08;
if (pFormats_.Contains(wave_format_2m16)) fDSCCAPS.dwFormats |= WAVE_FORMAT_2M16;
if (pFormats_.Contains(wave_format_2s08)) fDSCCAPS.dwFormats |= WAVE_FORMAT_2S08;
if (pFormats_.Contains(wave_format_2s16)) fDSCCAPS.dwFormats |= WAVE_FORMAT_2S16;
if (pFormats_.Contains(wave_format_4m08)) fDSCCAPS.dwFormats |= WAVE_FORMAT_4M08;
if (pFormats_.Contains(wave_format_4m16)) fDSCCAPS.dwFormats |= WAVE_FORMAT_4M16;
if (pFormats_.Contains(wave_format_4s08)) fDSCCAPS.dwFormats |= WAVE_FORMAT_4S08;
if (pFormats_.Contains(wave_format_4s16)) fDSCCAPS.dwFormats |= WAVE_FORMAT_4S16;
}
// --------------------------------------------------------------------------
// Method:      FGetFormats_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Formats' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDSCCaps::FGetFormats_Strings()
{
// if the strings have not been allocated
if (fFormats_Strings==NULL)
    {
    // attempt to allocate the strings
    fFormats_Strings = new TStringList();
    // if the allocation failed
    if (fFormats_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDSCCaps::FGetFormats_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Formats_Strings" );
        return NULL;
        }
    }
fFormats_Strings->Clear();
if (fDSCCAPS.dwFormats & WAVE_FORMAT_1M08) fFormats_Strings->Add("WAVE_FORMAT_1M08");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_1M16) fFormats_Strings->Add("WAVE_FORMAT_1M16");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_1S08) fFormats_Strings->Add("WAVE_FORMAT_1S08");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_1S16) fFormats_Strings->Add("WAVE_FORMAT_1S16");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_2M08) fFormats_Strings->Add("WAVE_FORMAT_2M08");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_2M16) fFormats_Strings->Add("WAVE_FORMAT_2M16");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_2S08) fFormats_Strings->Add("WAVE_FORMAT_2S08");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_2S16) fFormats_Strings->Add("WAVE_FORMAT_2S16");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_4M08) fFormats_Strings->Add("WAVE_FORMAT_4M08");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_4M16) fFormats_Strings->Add("WAVE_FORMAT_4M16");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_4S08) fFormats_Strings->Add("WAVE_FORMAT_4S08");
if (fDSCCAPS.dwFormats & WAVE_FORMAT_4S16) fFormats_Strings->Add("WAVE_FORMAT_4S16");
return fFormats_Strings;
}
// --------------------------------------------------------------------------
