// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_Sound3DListener.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDx_Sound3DListener 
//               Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_Sound3DListener.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_Sound3DListener component.
#include "TDx_SoundBuffer.H"
// --------------------------------------------------------------------------
// external classes used by TDx_Sound3DListener methods.
#include "TDS3DListener.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_Sound3DListener*)
{
    new TDx_Sound3DListener(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_sound3dlistener
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_Sound3DListener)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDx_Sound3DListener::TDx_Sound3DListener()
// Description: The default constructor for the TDx_Sound3DListener object.
// --------------------------------------------------------------------------
__fastcall TDx_Sound3DListener::TDx_Sound3DListener(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = DS_OK;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_Sound3DListener::~TDx_Sound3DListener()
// Description: The destructor for the TDx_Sound3DListener object.
// --------------------------------------------------------------------------
__fastcall TDx_Sound3DListener::~TDx_Sound3DListener()
{
// destroy internals
if (Created) Destroy();
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDIRECTSOUND3DLISTENER used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDIRECTSOUND3DLISTENER, call the 
//              TDx_Sound3DListener::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Sound3DListener::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDIRECTSOUND3DLISTENER==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_Sound3DListener method or 
//              fget/fset. eg. DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_Sound3DListener::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Sound3DListener::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Method:      CommitDeferredSettings()
// Description: The TDx_Sound3DListener::CommitDeferredSettings method will 
//              commit any deferred settings that have been applied since the 
//              last call to this method. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::CommitDeferredSettings()
{
// Original Function Definition
// HRESULT CommitDeferredSettings(); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::CommitDeferredSettings()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->CommitDeferredSettings(  );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::CommitDeferredSettings()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDIRECTSOUND3DLISTENER interface used in the 
//              TDx_Sound3DListener component and must be called before any 
//              methods of the TDx_Sound3DListener component will function. 
// Params:      pSoundBuffer - 
//                The SoundBuffer parameter references the existing 
//                TDx_SoundBuffer component from which the TDx_Sound3DListener 
//                is to be created. The sound buffer referenced by this 
//                parameter must have been created with the DSBCAPS_CTRL3D and 
//                DSBCAPS_PRIMARYBUFFER flag set. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::Create( TDx_SoundBuffer* pSoundBuffer )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created successfully." );
    return false;
    }

// check params for accuracy
if (pSoundBuffer==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pSoundBuffer' parameter must point to an existing TDx_SoundBuffer component and cannot be NULL." );
    return false;
    }

// check that the 3D sound buffer has been created
if (!pSoundBuffer->Created) 
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The TDx_Sound3DListener cannot be created because the TDx_SoundBuffer component specified by the 'pSoundBuffer' parameter has not yet been created." );
    return false;
    }

// code that creates the internal IDirectSound3DListener interface
fErrorValue = pSoundBuffer->Internal_LPDIRECTSOUNDBUFFER->QueryInterface( IID_IDirectSound3DListener, (LPVOID*)&fLPDIRECTSOUND3DLISTENER);

if (fErrorValue!=DS_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The "+Name+"::Create() method failed because LPDIRECTSOUNDBUFFER->QueryInterface(IID_IDirectSound3DListener) failed with error: "+TDx_Sound_Library_ErrorString(fErrorValue)+", "+TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);
return true;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDIRECTSOUND3DLISTENER interface used in the 
//              TDx_Sound3DListener component and should be called when the 
//              internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// code that destroys the internal interface
if (FOnDestroy) FOnDestroy(this);

if (fLPDIRECTSOUND3DLISTENER==NULL) 
    { 
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "The "+Name+" component's internal LPDIRECTSOUND3DLISTENER is NULL but the TDx_Sound component is expecting it to be not NULL. Aborting the Destroy()." );
    return false;
    }

try { 
    fLPDIRECTSOUND3DLISTENER->Release(); 
    } 
catch (...) 
    { 
    fErrorValue = TDX_ERROR; 
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception has occurred within LPDIRECTSOUND3DLISTENER->Release(). Check that you are destroying all components in reverse order of creation." );
    }

// successful destruction
fLPDIRECTSOUND3DLISTENER = NULL;
fCreated = false;
return true;
}

// --------------------------------------------------------------------------
// Method:      GetAllParameters()
// Description: The TDx_Sound3DListener::GetAllParameters method will return 
//              the current 3D characteristics of the 3D world and the 
//              listener. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pListener - 
//                The Listener parameter references a TDS3DListener component 
//                for holding the current state of the 3D world and listener if 
//                this method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::GetAllParameters( TDS3DListener* pListener )
{
// Original Function Definition
// HRESULT GetAllParameters( 
//   LPDS3DLISTENER lpListener   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetAllParameters()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pListener==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetAllParameters()", "TDX_BADPARAMS", "'pListener' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->GetAllParameters( pListener->Internal_DS3DLISTENER_Ptr );

// Translate Data returned from Function
pListener->Internal_DS3DLISTENER_Update();

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetAllParameters()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetDistanceFactor()
// Description: The TDx_Sound3DListener::GetDistanceFactor method will return 
//              the current distance factor setting for the listener. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pDistanceFactor - 
//                The DistanceFactor parameter references a D3DVALUE for 
//                holding the current distance factor setting for the listener 
//                if this method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::GetDistanceFactor( D3DVALUE* pDistanceFactor )
{
// Original Function Definition
// HRESULT GetDistanceFactor( 
//   LPD3DVALUE lpflDistanceFactor   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetDistanceFactor()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pDistanceFactor==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetDistanceFactor()", "TDX_BADPARAMS", "'pDistanceFactor' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->GetDistanceFactor( (LPD3DVALUE) pDistanceFactor );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetDistanceFactor()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetDopplerFactor()
// Description: The TDx_Sound3DListener::GetDopplerFactor method will return 
//              the doppler factor currently set for the listener. 
//              The minimum, maximum and default doppler values are defined 
//              in the dsound.h DS3D_MINDOPPLERFACTOR, DS3D_MAXDOPPLERFACTOR 
//              and DS3D_DEFAULTDOPPLERFACTOR members as 0.0, 10.0 and 1.0 
//              respectively. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pDopplerFactor - 
//                The DopplerFactor parameter references a D3DVALUE for holding 
//                the doppler factor currently set for the listener if this 
//                method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::GetDopplerFactor( D3DVALUE* pDopplerFactor )
{
// Original Function Definition
// HRESULT GetDopplerFactor( 
//   LPD3DVALUE lpflDopplerFactor   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetDopplerFactor()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pDopplerFactor==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetDopplerFactor()", "TDX_BADPARAMS", "'pDopplerFactor' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->GetDopplerFactor( (LPD3DVALUE) pDopplerFactor );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetDopplerFactor()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetOrientation()
// Description: The TDx_Sound3DListener::GetOrientation method will return 
//              the orientation currently set for the listener. 
//              The front and top vectors meet at right angles within the 
//              listeners head. The vectors may be adjusted to ensure they 
//              are at right angles with a magnitude of less than one and 
//              thus the values of the vectors may not be the same as when 
//              they were set. 
//              The front vector indicates the direction of the listeners 
//              nose, while the top vector points out the top of the 
//              listeners head. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pOrientFront - 
//                The OrientFront parameter references a D3DVECTOR for holding 
//                the listener's front orientation if this method returns 
//                successfully. 
//              pOrientTop - 
//                The OrientTop parameter references a D3DVECTOR for holding 
//                this listener's top orientation if this method returns 
//                successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::GetOrientation( D3DVECTOR* pOrientFront, D3DVECTOR* pOrientTop )
{
// Original Function Definition
// HRESULT GetOrientation( 
//   LPD3DVECTOR lpvOrientFront,   
//   LPD3DVECTOR lpvOrientTop   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetOrientation()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pOrientFront==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetOrientation()", "TDX_BADPARAMS", "'pOrientFront' cannot be 'NULL'");
    return false;
    }
if (pOrientTop==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetOrientation()", "TDX_BADPARAMS", "'pOrientTop' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->GetOrientation( (LPD3DVECTOR) pOrientFront, (LPD3DVECTOR) pOrientTop );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetOrientation()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetPosition()
// Description: The TDx_Sound3DListener::GetPosition method will return the 
//              current position, in distance units, of the listener. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pPosition - 
//                The Position parameter references a D3DVECTOR for holding the 
//                listener's current position vector if this method returns 
//                successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::GetPosition( D3DVECTOR* pPosition )
{
// Original Function Definition
// HRESULT GetPosition( 
//   LPD3DVECTOR lpvPosition   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetPosition()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pPosition==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetPosition()", "TDX_BADPARAMS", "'pPosition' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->GetPosition( (LPD3DVECTOR) pPosition );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetPosition()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetRolloffFactor()
// Description: The TDx_Sound3DListener::GetRolloffFactor method will return 
//              the rolloff factor currently set for the listener. 
//              The minimum, maximum and default rolloff values are defined 
//              in the dsound.h DS3D_MINROLLOFFFACTOR, DS3D_MAXROLLOFFFACTOR 
//              and DS3D_DEFAULTROLLOFFFACTOR members as 0.0, 10.0 and 1.0 
//              respectively. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pRolloffFactor - 
//                The RolloffFactor parameter references a D3DVALUE for holding 
//                the current rolloff factor if this method returns 
//                successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::GetRolloffFactor( D3DVALUE* pRolloffFactor )
{
// Original Function Definition
// HRESULT GetRolloffFactor( 
//   LPD3DVALUE lpflRolloffFactor   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetRolloffFactor()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->GetRolloffFactor( (LPD3DVALUE) pRolloffFactor );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetRolloffFactor()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetVelocity()
// Description: The TDx_Sound3DListener::GetVelocity method will return the 
//              current velocity set for the listener. 
//              This value is used to calculate doppler effects only, it is 
//              up to the application to move the buffer appropriately. 
//              The default velocity is (0,0,0). 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pVelocity - 
//                The Velocity parameter references a D3DVECTOR for holding the 
//                listener's current velocity if this method returns 
//                successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::GetVelocity( D3DVECTOR* pVelocity )
{
// Original Function Definition
// HRESULT GetVelocity( 
//   LPD3DVECTOR lpvVelocity   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetVelocity()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pVelocity==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetVelocity()", "TDX_BADPARAMS", "'pVelocity' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->GetVelocity( (LPD3DVECTOR) pVelocity );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetVelocity()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetAllParameters()
// Description: The TDx_Sound3DListener::SetAllParameters method will set the 
//              3D characteristics for the 3D world and the listener. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pListener - 
//                The Listener parameter references a TDS3DListener component 
//                holding the 3D listener properties to be set. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied straight away. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until the 
//                    TDx_Sound3DListener::CommitDeferredSettings method is 
//                    called before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::SetAllParameters( TDS3DListener* pListener, dword pApply )
{
// Original Function Definition
// HRESULT SetAllParameters( 
//   LPCDS3DLISTENER lpcListener,   
//   DWORD dwApply                 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetAllParameters()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pListener==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::SetAllParameters()", "TDX_BADPARAMS", "'pListener' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->SetAllParameters( pListener->Internal_DS3DLISTENER_Ptr, (DWORD) pApply );

// Translate Data returned from Function
pListener->Internal_DS3DLISTENER_Update();

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetAllParameters()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetDistanceFactor()
// Description: The TDx_Sound3DListener::SetDistanceFactor method will set 
//              the distance factor for the listener. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pDistanceFactor - 
//                The DistanceFactor parameter defines the distance factor to 
//                be set for the listener. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied straight away. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until the 
//                    TDx_Sound3DListener::CommitDeferredSettings method is 
//                    called before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::SetDistanceFactor( D3DVALUE pDistanceFactor, dword pApply )
{
// Original Function Definition
// HRESULT SetDistanceFactor( 
//   D3DVALUE flDistanceFactor,   
//   DWORD dwApply               
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetDistanceFactor()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->SetDistanceFactor( pDistanceFactor, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetDistanceFactor()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetDopplerFactor()
// Description: The TDx_Sound3DListener::SetDopplerFactor method will set the 
//              doppler factor for the listener. 
//              The minimum, maximum and default doppler values are defined 
//              in the dsound.h DS3D_MINDOPPLERFACTOR, DS3D_MAXDOPPLERFACTOR 
//              and DS3D_DEFAULTDOPPLERFACTOR members as 0.0, 10.0 and 1.0 
//              respectively. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pDopplerFactor - 
//                The DopplerFactor parameter defines the doppler factor to be 
//                set for the listener. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied straight away. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until the 
//                    TDx_Sound3DListener::CommitDeferredSettings method is 
//                    called before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::SetDopplerFactor( D3DVALUE pDopplerFactor, dword pApply )
{
// Original Function Definition
// HRESULT SetDopplerFactor( 
//   D3DVALUE flDopplerFactor,   
//   DWORD dwApply               
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetDopplerFactor()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->SetDopplerFactor( pDopplerFactor, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetDopplerFactor()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetOrientation()
// Description: The TDx_Sound3DListener::SetOrientation method will set the 
//              orientation for the listener. 
//              The front and top vectors meet at right angles within the 
//              listeners head. 
//              The front vector may be adjusted to ensure it is at right 
//              angles to the top vectoor. 
//              Both vectors may be adjusted to ensure they have a magnitude 
//              of less than one. 
//              The front vector indicates the direction of the listeners 
//              nose, while the top vector points out the top of the 
//              listeners head. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pXFront - 
//                The XFront parameter defines a D3DVALUE representing the new 
//                X coordinate of the front orientation vector. 
//              pYFront - 
//                The YFront parameter defines a D3DVALUE representing the new 
//                Y coordinate of the front orientation vector. 
//              pZFront - 
//                The ZFront parameter defines a D3DVALUE representing the new 
//                Z coordinate of the front orientation vector. 
//              pXTop - 
//                The XTop parameter defines a D3DVALUE representing the new X 
//                coordinate of the top orientation vector. 
//              pYTop - 
//                The YTop parameter defines a D3DVALUE representing the new Y 
//                coordinate of the top orientation vector. 
//              pZTop - 
//                The ZTop parameter defines a D3DVALUE representing the new Z 
//                coordinate of the top orientation vector. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied straight away. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until the 
//                    TDx_Sound3DListener::CommitDeferredSettings method is 
//                    called before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::SetOrientation( D3DVALUE pXFront, D3DVALUE pYFront, D3DVALUE pZFront, D3DVALUE pXTop, D3DVALUE pYTop, D3DVALUE pZTop, dword pApply )
{
// Original Function Definition
// HRESULT SetOrientation( 
//   D3DVALUE xFront,   
//   D3DVALUE yFront,   
//   D3DVALUE zFront,   
//   D3DVALUE xTop,     
//   D3DVALUE yTop,     
//   D3DVALUE zTop,     
//   DWORD dwApply     
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetOrientation()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->SetOrientation( pXFront, pYFront, pZFront, pXTop, pYTop, pZTop, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetOrientation()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetPosition()
// Description: The TDx_Sound3DListener::SetPosition method will set the 
//              position, in distance units, for the listener. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pX - 
//                The X parameter defines a D3DVALUE representing the new X 
//                coordinate for the position vector. 
//                This value may be adjusted to prevent floating point 
//                overflow. 
//              pY - 
//                The Y parameter defines a D3DVALUE representing the new Y 
//                coordinate for the position vector. 
//                This value may be adjusted to prevent floating point 
//                overflow. 
//              pZ - 
//                The Z parameter defines a D3DVALUE representing the new Z 
//                coordinate for the position vector. 
//                This value may be adjusted to prevent floating point 
//                overflow. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied straight away. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until the 
//                    TDx_Sound3DListener::CommitDeferredSettings method is 
//                    called before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::SetPosition( D3DVALUE pX, D3DVALUE pY, D3DVALUE pZ, dword pApply )
{
// Original Function Definition
// HRESULT SetPosition( 
//   D3DVALUE x,     
//   D3DVALUE y,     
//   D3DVALUE z,     
//   DWORD dwApply   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetPosition()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->SetPosition( pX, pY, pZ, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetPosition()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetRolloffFactor()
// Description: The TDx_Sound3DListener::SetRolloffFactor method will set the 
//              rolloff factor for the listener. 
//              The minimum, maximum and default rolloff values are defined 
//              in the dsound.h DS3D_MINROLLOFFFACTOR, DS3D_MAXROLLOFFFACTOR 
//              and DS3D_DEFAULTROLLOFFFACTOR members as 0.0, 10.0 and 1.0 
//              respectively. 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pRolloffFactor - 
//                The RolloffFactor parameter defines the rolloff factor to be 
//                set for the listener. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied straight away. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until the 
//                    TDx_Sound3DListener::CommitDeferredSettings method is 
//                    called before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::SetRolloffFactor( D3DVALUE pRolloffFactor, dword pApply )
{
// Original Function Definition
// HRESULT SetRolloffFactor( 
//   D3DVALUE flRolloffFactor,   
//   DWORD dwApply               
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetRolloffFactor()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->SetRolloffFactor( pRolloffFactor, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetRolloffFactor()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetVelocity()
// Description: The TDx_Sound3DListener::SetVelocity method will set the 
//              velocity for the listener. 
//              This value is used to calculate doppler effects only, it is 
//              up to the application to move the buffer appropriately. 
//              The default velocity is (0,0,0). 
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pX - 
//                The X parameter defines a D3DVALUE representing the new X 
//                coordinate of the velocity vector. 
//              pY - 
//                The Y parameter defines a D3DVALUE representing the new Y 
//                coordinate of the velocity vector. 
//              pZ - 
//                The Z parameter defines a D3DVALUE representing the new Z 
//                coordinate of the velocity vector. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied straight away. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until the 
//                    TDx_Sound3DListener::CommitDeferredSettings method is 
//                    called before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DListener::SetVelocity( D3DVALUE pX, D3DVALUE pY, D3DVALUE pZ, dword pApply )
{
// Original Function Definition
// HRESULT SetVelocity( 
//   D3DVALUE x,     
//   D3DVALUE y,     
//   D3DVALUE z,     
//   DWORD dwApply   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetVelocity()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DLISTENER->SetVelocity( pX, pY, pZ, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetVelocity()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDIRECTSOUND3DLISTENER __fastcall TDx_Sound3DListener::FGetInternal_LPDIRECTSOUND3DLISTENER()
{
return fLPDIRECTSOUND3DLISTENER;
}
// --------------------------------------------------------------------------
LPDIRECTSOUND3DLISTENER* __fastcall TDx_Sound3DListener::FGetInternal_LPDIRECTSOUND3DLISTENER_Ptr()
{
return &fLPDIRECTSOUND3DLISTENER;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Sound3DListener::FSetInternal_LPDIRECTSOUND3DLISTENER( LPDIRECTSOUND3DLISTENER pLPDIRECTSOUND3DLISTENER )
{
if (!fCreated)
    {
    fLPDIRECTSOUND3DLISTENER = pLPDIRECTSOUND3DLISTENER;
    fCreated = (fLPDIRECTSOUND3DLISTENER!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_Sound3DListener::Internal_LPDIRECTSOUND3DLISTENER_Update()
{
fCreated = (fLPDIRECTSOUND3DLISTENER!=NULL);
}

// --------------------------------------------------------------------------
