// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_SoundKsPropertySet.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDx_SoundKsPropertySet 
//               Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_SoundKsPropertySet.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_SoundKsPropertySet component.
#include "TDx_SoundBuffer.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_SoundKsPropertySet*)
{
    new TDx_SoundKsPropertySet(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_soundkspropertyset
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_SoundKsPropertySet)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDx_SoundKsPropertySet::TDx_SoundKsPropertySet()
// Description: The default constructor for the TDx_SoundKsPropertySet object.
// --------------------------------------------------------------------------
__fastcall TDx_SoundKsPropertySet::TDx_SoundKsPropertySet(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = DS_OK;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_SoundKsPropertySet::~TDx_SoundKsPropertySet()
// Description: The destructor for the TDx_SoundKsPropertySet object.
// --------------------------------------------------------------------------
__fastcall TDx_SoundKsPropertySet::~TDx_SoundKsPropertySet()
{
// destroy internals
if (Created) Destroy();
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal LPKSPROPERTYSET 
//              used in this component has been successfully created, 
//              otherwise Created is false. 
//              
//              To create the internal LPKSPROPERTYSET, call the 
//              TDx_SoundKsPropertySet::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundKsPropertySet::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundKsPropertySet::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPKSPROPERTYSET==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_SoundKsPropertySet method or 
//              fget/fset. eg. DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_SoundKsPropertySet::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundKsPropertySet::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPKSPROPERTYSET interface used in the 
//              TDx_SoundKsPropertySet component and must be called before 
//              any methods of the TDx_SoundKsPropertySet component will 
//              function. 
// Params:      pSoundBuffer - 
//                The SoundBuffer parameter references the existing 
//                TDx_SoundBuffer component for which the sound buffer is to be 
//                created. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundKsPropertySet::Create( TDx_SoundBuffer* pSoundBuffer )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created successfully." );
    return false;
    }

// check params for accuracy
if (pSoundBuffer==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pSoundBuffer' parameter must point to an existing TDx_SoundBuffer component and cannot be NULL." );
    return false;
    }

// check that the sound buffer has been created
if (!pSoundBuffer->Created) 
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The TDx_SoundKsPropertySet component cannot be created because the TDx_SoundBuffer component specified by the 'pSoundBuffer' parameter has not yet been created." );
    return false;
    }

// code that creates the internal IKsPropertySet interface
fErrorValue = pSoundBuffer->Internal_LPDIRECTSOUNDBUFFER->QueryInterface( IID_IKsPropertySet, (LPVOID*)&fLPKSPROPERTYSET);

if (fErrorValue!=DS_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The "+Name+"::Create() method failed because LPDIRECTSOUNDBUFFER->QueryInterface(IID_IKsPropertySet) failed with error: "+TDx_Sound_Library_ErrorString(fErrorValue)+", "+TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);
return true;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPKSPROPERTYSET interface used in the 
//              TDx_SoundKsPropertySet component and should be called when 
//              the internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundKsPropertySet::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// code that destroys the internal interface
if (FOnDestroy) FOnDestroy(this);

if (fLPKSPROPERTYSET==NULL) 
    { 
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "The "+Name+" component's internal LPKSPROPERTYSET is NULL but the TDx_Sound component is expecting it to be not NULL. Aborting the Destroy()." );
    return false;
    }

try { 
    fLPKSPROPERTYSET->Release(); 
    } 
catch (...) 
    { 
    fErrorValue = TDX_ERROR; 
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception has occurred within LPKSPROPERTYSET->Release(). Check that you are destroying all components in reverse order of creation." );
    }

// successful destruction
fLPKSPROPERTYSET = NULL;
fCreated = false;
return true;
}

// --------------------------------------------------------------------------
// Method:      Get()
// Description: The TDx_SoundKsPropertySet::Get method will return the value 
//              currently set for a property. 
//              
//              The value of the property will be copied to the buffer 
//              referenced by the PropertyData parameter of this method. 
//              
//              The format of the data in the InstanceData and Property 
//              parameters is item specific. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              E_POINTER 
// Params:      pPropertySet - 
//                The PropertySet parameter defines the GUID of the property 
//                set to be accessed. 
//              pId - 
//                The Id parameter defines the identifier of the individual 
//                property to be retrieved. 
//                This must be a property contained within the property set 
//                indicated by the PropertySetId parameter of this method. 
//                This identifier is indexed from zero and will always be 
//                consistant for a given property set GUID. 
//              pInstanceData - 
//                The InstanceData parameter references the instance data for 
//                the retrieval. 
//              pInstanceLength - 
//                The InstanceLength parameter number of bytes referenced by 
//                the InstanceData parameter of this method. 
//              pPropertyData - 
//                The PropertyData parameter references the property data 
//                buffer for the retrieval. 
//              pDataLength - 
//                The DataLength parameter defines number of bytes referenced 
//                by the PropertyData parameter of this method. 
//              pBytesReturned - 
//                The BytesReturned parameter defines the number of bytes 
//                written to the PropertyData parameter of this method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundKsPropertySet::Get( REFGUID pPropertySet, ulong pId, void* pInstanceData, ulong pInstanceLength, void* pPropertyData, ulong pDataLength, ulong* pBytesReturned )
{
// Original Function Definition
// HRESULT Get( 
//   REFGUID rguidPropSet, 
//   ULONG ulId, 
//   LPVOID pInstanceData, 
//   ULONG ulInstanceLength, 
//   LPVOID pPropertyData, 
//   ULONG ulDataLength, 
//   ULONG* pulBytesReturned 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Get()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPKSPROPERTYSET->Get( pPropertySet, (ULONG) pId, (LPVOID) pInstanceData, (ULONG) pInstanceLength, (LPVOID) pPropertyData, (ULONG) pDataLength, (ULONG*) pBytesReturned );

// Handle any Known Results
if (fErrorValue!=S_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Get()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      QuerySupport()
// Description: The TDx_SoundKsPropertySet::QuerySupport method will 
//              determine whether a component supports a specific property 
//              set. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              E_NOTIMPL 
//              E_POINTER 
// Params:      pPropertySetId - 
//                The PropertySetId parameter defines the GUID of the property 
//                set. 
//              pPropertyId - 
//                The PropertyId parameter defines the identifier of the 
//                property within the property set to check for support. 
//                This identifier is indexed from zero and will always be 
//                consistant for a given property set GUID. 
//              pSupport - 
//                The Support parameter will reference flags indicating the 
//                support available for the specified property if this method 
//                returns successfully. 
//                The described effect applies when the flag is set. 
//                This parameter will be set to zero if the property or 
//                property set does not exist. 
//                Flags:
//                  KSPROPERTY_SUPPORT_GET -
//                    The property can be read using 
//                    TDx_SoundKsPropertySet::Get. 
//                  KSPROPERTY_SUPPORT_SET -
//                    The property can be changed using 
//                    TDx_SoundKsPropertySet::Set. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundKsPropertySet::QuerySupport( REFGUID pPropertySetId, ulong pPropertyId, ulong* pSupport )
{
// Original Function Definition
// HRESULT QuerySupport( 
//   REFGUID rguidPropSet, 
//   ULONG ulId, 
//   ULONG* pulTypeSupport 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::QuerySupport()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPKSPROPERTYSET->QuerySupport( pPropertySetId, (ULONG) pPropertyId, (ULONG*) pSupport );

// Handle any Known Results
if (fErrorValue!=S_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::QuerySupport()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Set()
// Description: The TDx_SoundKsPropertySet::Set method will set a property to 
//              the specified value. 
//              The format of the data in the InstanceData and Property 
//              parameters is item specific. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              E_POINTER 
// Params:      pPropertySet - 
//                The PropertySet parameter defines the GUID of the property 
//                set. 
//              pId - 
//                The Id parameter defines the identifier of the individual 
//                property to be set. 
//                This must be a property contained within the property set 
//                indicated by the PropertySetId parameter of this method. 
//                This identifier is indexed from zero and will always be 
//                consistant for a given property set GUID. 
//              pInstanceData - 
//                The InstanceData parameter references the which instance is 
//                to be set. 
//                This parameter is used to uniquely identify an object when 
//                there are multiple objects within the port this operation is 
//                acting on. 
//              pInstanceLength - 
//                The InstanceLength parameter defines number of bytes 
//                referenced by the InstanceData parameter of this method. 
//              pPropertyData - 
//                The PropertyData parameter references a buffer holding the 
//                information to be set for the specified property. 
//              pDataLength - 
//                The DataLength parameter defines the number of bytes 
//                referenced by the PropertyData parameter of this method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundKsPropertySet::Set( REFGUID pPropertySet, ulong pId, void* pInstanceData, ulong pInstanceLength, void* pPropertyData, ulong pDataLength )
{
// Original Function Definition
// HRESULT Set( 
//   REFGUID rguidPropSet, 
//   ULONG ulId, 
//   LPVOID pInstanceData, 
//   ULONG ulInstanceLength, 
//   LPVOID pPropertyData, 
//   ULONG pulDataLength 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Set()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPKSPROPERTYSET->Set( pPropertySet, (ULONG) pId, (LPVOID) pInstanceData, (ULONG) pInstanceLength, (LPVOID) pPropertyData, (ULONG) pDataLength );

// Handle any Known Results
if (fErrorValue!=S_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Set()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPKSPROPERTYSET __fastcall TDx_SoundKsPropertySet::FGetInternal_LPKSPROPERTYSET()
{
return fLPKSPROPERTYSET;
}
// --------------------------------------------------------------------------
LPKSPROPERTYSET* __fastcall TDx_SoundKsPropertySet::FGetInternal_LPKSPROPERTYSET_Ptr()
{
return &fLPKSPROPERTYSET;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundKsPropertySet::FSetInternal_LPKSPROPERTYSET( LPKSPROPERTYSET pLPKSPROPERTYSET )
{
if (!fCreated)
    {
    fLPKSPROPERTYSET = pLPKSPROPERTYSET;
    fCreated = (fLPKSPROPERTYSET!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundKsPropertySet::Internal_LPKSPROPERTYSET_Update()
{
fCreated = (fLPKSPROPERTYSET!=NULL);
}

// --------------------------------------------------------------------------
