// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_SoundNotify.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDx_SoundNotify 
//               Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_SoundNotify.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_SoundNotify component.
#include "TDx_SoundBuffer.H"
#include "TDx_SoundCaptureBuffer.H"
// --------------------------------------------------------------------------
// external classes used by TDx_SoundNotify properties.
#include "TDSBPositionNotify.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_SoundNotify*)
{
    new TDx_SoundNotify(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_soundnotify
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_SoundNotify)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Global Variables used internally by the TDx_SoundNotify component.
// --------------------------------------------------------------------------
TDx_SoundNotify* TDx_SoundNotify_ThreadParent = NULL;

// --------------------------------------------------------------------------

class TDx_SoundNotify_ThreadClass : public TThread
{
public:
    __property bool HandlesModified = {write=fHandlesModified, default=true};

    void __fastcall DoNothing() {} // minor delay due to method call
    void __fastcall Pause()     // called only by other threads, never this thread
                        {
                        while (fRebuildingHandles) DoNothing();
                        SetEvent( fPauseEvent );
                        }
    void __fastcall Restart()   // called only by other threads, never this thread
                        {
                        while (fRebuildingHandles) DoNothing();
                        SetEvent( fRestartEvent );
                        }
    void __fastcall TerminateImmediately()   // called only by other threads, never this thread
                        {
                        while (fRebuildingHandles) DoNothing();
                        SetEvent( fTerminateEvent );
                        }
    void __fastcall RebuildHandles();

    __fastcall TDx_SoundNotify_ThreadClass();
    virtual __fastcall ~TDx_SoundNotify_ThreadClass();

protected:

    void __fastcall Execute();
    void __fastcall Translate();

private:
    HANDLE*             fHandles;
    TDx_SoundNotify**   fHandleOwners;
    int                 fNumHandles;

    int                 fEventNum;
    
    bool                fHandlesModified;
    bool                fRebuildingHandles;

    HANDLE              fPauseEvent;
    HANDLE              fRestartEvent;
    HANDLE              fTerminateEvent;
    int                 fPauseIndex;
    int                 fRestartIndex;
    int                 fTerminateIndex;
};
//---------------------------------------------------------------------------

static TList* TDx_SoundNotify_ComponentList = NULL;
static TDx_SoundNotify_ThreadClass* TDx_SoundNotify_Thread = NULL;

// --------------------------------------------------------------------------
// Global Functions used internally by the TDx_SoundNotify component.
// --------------------------------------------------------------------------

__fastcall TDx_SoundNotify_ThreadClass::TDx_SoundNotify_ThreadClass()
	: TThread(true)
{
fHandles = NULL;
fNumHandles = 0;
fEventNum = 0;

fPauseEvent = CreateEvent( NULL, FALSE, FALSE, NULL ); fPauseIndex = -1;
fRestartEvent = CreateEvent( NULL, FALSE, FALSE, NULL ); fRestartIndex = -1;
fTerminateEvent = CreateEvent( NULL, FALSE, FALSE, NULL ); fTerminateIndex = -1;

fHandlesModified = true;
fRebuildingHandles = false;
}
//---------------------------------------------------------------------------
__fastcall TDx_SoundNotify_ThreadClass::~TDx_SoundNotify_ThreadClass()
{
if (fHandles) { delete[] fHandles; fHandles = NULL; fNumHandles = 0; }

if (fTerminateEvent) { CloseHandle( fTerminateEvent ); fTerminateEvent = NULL; }
if (fRestartEvent) { CloseHandle( fRestartEvent ); fRestartEvent = NULL; }
if (fPauseEvent) { CloseHandle( fPauseEvent ); fPauseEvent = NULL; }
}
//---------------------------------------------------------------------------
void __fastcall TDx_SoundNotify_ThreadClass::Execute()
{
FreeOnTerminate = true;

// wait for events
while (true)
    {
    // rebuild handles iff required
    if (fHandlesModified)
    	{
        fRebuildingHandles = true;
        RebuildHandles();
        fHandlesModified = false;       // do not change the order of these 2 bools
        fRebuildingHandles = false;     // because other threads might be waiting for -this- result before changing ^one
        }

    // wait for notifications + pause, restart, terminate events
    fEventNum = WaitForMultipleObjects( fNumHandles+3, fHandles, FALSE, INFINITE );

    // if for some reason the handles were invalid, re-try
    if (fEventNum==WAIT_FAILED)
        {
        fHandlesModified = true;    // force a rebuild of the handles
        continue;
        }

    // modify the result
    fEventNum -= WAIT_OBJECT_0;

    // if it's a pause, wait for a resume or a terminate
    if (fEventNum == fPauseIndex)
        {
        // wait for restart / terminate event
        fEventNum = WaitForMultipleObjects( 2, &fHandles[fRestartIndex], FALSE, INFINITE );
        }

    // if it's a restart, simply restart
    if (fEventNum == fRestartIndex) 
        {
        continue;
        }

    // if it's a terminate event, exit immediately
    if (fEventNum == fTerminateIndex)
        {
        break;
        }

    // otherwise, the event is a notification event, send it to the user
    if (fEventNum < fNumHandles)
        {
        Synchronize(Translate);
        }
    }
// finished
}
//---------------------------------------------------------------------------
void __fastcall TDx_SoundNotify_ThreadClass::RebuildHandles()
{
if (fHandles) { delete[] fHandles; fHandles = NULL; fNumHandles = 0; }
if (fHandleOwners) { delete[] fHandleOwners; fHandleOwners = NULL; }

// determine the number of handles that need to be added
int num_handles = 0;
for (int i=0;i<TDx_SoundNotify_ComponentList->Count;i++)
	{
	TDx_SoundNotify* notify = (TDx_SoundNotify*) TDx_SoundNotify_ComponentList->Items[i];
	if (notify)
    	if (notify->Created)
            num_handles += notify->NumPositionNotifies;
    }

// allocate storage for handles and something to tell us who the handle refers to
fHandles = new HANDLE [num_handles+3];
if (!fHandles) return;
fHandleOwners = new TDx_SoundNotify* [num_handles+3];
if (!fHandleOwners) { delete[] fHandles; fHandles = NULL; return; }

fNumHandles = num_handles;

// add notification events to internal storage
int pos = 0;
for (int i=0;i<TDx_SoundNotify_ComponentList->Count;i++)
    {
    TDx_SoundNotify* notify = (TDx_SoundNotify*) TDx_SoundNotify_ComponentList->Items[i];
    if (notify)
        if (notify->Created)
            if (notify->PositionNotifies!=NULL)
                for (dword j=0;j<notify->NumPositionNotifies;j++)
                    {
                    fHandles[pos] = notify->PositionNotifies->EventNotify[j];
                    fHandleOwners[pos] = notify;
                    pos++;
                    }
    }

// add pause, restart, terminate events
fPauseIndex = fNumHandles; fHandles[fPauseIndex] = fPauseEvent;
fRestartIndex = fNumHandles+1; fHandles[fRestartIndex] = fRestartEvent;
fTerminateIndex = fNumHandles+2; fHandles[fTerminateIndex] = fTerminateEvent;
}
//---------------------------------------------------------------------------
void __fastcall TDx_SoundNotify_ThreadClass::Translate()
{
// if the handles were modified during the synchronize, abort immediately
if (fHandlesModified)
    {
    return;
    }

// send it to the relevant BCB event handler
try
    {
    TDx_SoundNotify* notify = fHandleOwners[fEventNum];
    // if the event is meant to go directly to the local TDSBPositionNotify::OnNotify() event
    if (notify->LocalNotify)
        {
        // send to the TDx_SoundNotify::OnNotify() event
        if (notify->OnNotify) notify->OnNotify( notify, fEventNum );
        }
    else
        {
        // send to the appropriate TDSBPositionNotify::OnNotify() event
        if (notify->PositionNotifies)
            if (notify->PositionNotifies->OnNotify)
                notify->PositionNotifies->OnNotify( notify, fEventNum );
        }
    }
// absorb anything extraordinary
catch (...) {}
}

// --------------------------------------------------------------------------
// Constructor: TDx_SoundNotify::TDx_SoundNotify()
// Description: The default constructor for the TDx_SoundNotify object.
// --------------------------------------------------------------------------
__fastcall TDx_SoundNotify::TDx_SoundNotify(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = DS_OK;
fLocalNotify = true;
fPositionNotifies = NULL;
fNumPositionNotifies = 0;

// only create the thread at runtime.
// if we're not currently running inside the BCB ide...
bool inside_ide = false;
if (Screen)
   if (Screen->ActiveForm)
       if (Screen->ActiveForm->Designer) inside_ide = true;

if (!inside_ide)
    {
    if (TDx_SoundNotify_ThreadParent==NULL)
    	{
        TDx_SoundNotify_ComponentList = new TList();
        if (TDx_SoundNotify_ComponentList)
            {
            TDx_SoundNotify_Thread = new TDx_SoundNotify_ThreadClass();
            if (TDx_SoundNotify_Thread)
                {
                TDx_SoundNotify_ThreadParent=this;
                TDx_SoundNotify_Thread->Resume();   // set the thread running...
                }
            else
            	{
                delete TDx_SoundNotify_ComponentList; TDx_SoundNotify_ComponentList = NULL;
                TDx_SoundNotify_ThreadParent = NULL;
                }
            }
        }
    }
}
// --------------------------------------------------------------------------
// Destructor:  TDx_SoundNotify::~TDx_SoundNotify()
// Description: The destructor for the TDx_SoundNotify object.
// --------------------------------------------------------------------------
__fastcall TDx_SoundNotify::~TDx_SoundNotify()
{
// make sure to destroy internals
if (Created) Destroy();

// destroy the thread iff required
if (TDx_SoundNotify_Thread!=NULL)
    if (TDx_SoundNotify_ThreadParent==this)
        {
        TDx_SoundNotify_Thread->Pause();
        
        // remove from list
        if (TDx_SoundNotify_ComponentList)
            if (TDx_SoundNotify_ComponentList->IndexOf(this)!=-1)
                TDx_SoundNotify_ComponentList->Delete(TDx_SoundNotify_ComponentList->IndexOf(this));

        // if there are any other components still alive, migrate the parent
        bool migrated = false;
        for (int i=0;i<TDx_SoundNotify_ComponentList->Count;i++)
        	if (TDx_SoundNotify_ComponentList->Items[i]!=NULL)
            	{
                TDx_SoundNotify_ThreadParent = (TDx_SoundNotify*) TDx_SoundNotify_ComponentList->Items[i];
                migrated = true;
                break;
                }
        // if could not migrate, destroy the thread and the component list
        if (!migrated)
        	{
            TDx_SoundNotify_Thread->TerminateImmediately();
            TDx_SoundNotify_Thread = NULL;
            delete TDx_SoundNotify_ComponentList; TDx_SoundNotify_ComponentList = NULL;
            TDx_SoundNotify_ThreadParent = NULL;
            }
        else
            // restart the thread with the new parent.
            {
            TDx_SoundNotify_Thread->HandlesModified = true;
            TDx_SoundNotify_Thread->Restart();
            }
        }
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDIRECTSOUNDNOTIFY used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDIRECTSOUNDNOTIFY, call the 
//              TDx_SoundNotify::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundNotify::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundNotify::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDIRECTSOUNDNOTIFY==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_SoundNotify method or 
//              fget/fset. eg. DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_SoundNotify::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundNotify::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    LocalNotify
// Description: The LocalNotify property is used to toggle the destination 
//              for DirectX buffer notification events created using 
//              TDx_SoundNotify::SetNotificationPositions(). 
//              
//              If the LocalNotify property is true, the 
//              TDx_SoundNotify::OnNotify() event is called with 
//              (0..number_of_events-1). 
//              
//              If the LocalNotify property is false, the 
//              TDSBPositionNotify::OnNotify() event of the appropriate 
//              component is called. 
//              
//              By default, LocalNotify is true. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundNotify::FGetLocalNotify()
{
return fLocalNotify;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundNotify::FSetLocalNotify( bool pLocalNotify )
{
fLocalNotify = pLocalNotify;
}
// --------------------------------------------------------------------------
// Property:    NumPositionNotifies
// Description: The NumPositionNotifies property holds the number of 
//              notification positions set during the last call to 
//              TDx_SoundNotify::SetNotificationPositions(). 
//              
//              This property is used internally but can be examined for 
//              external use. 
// --------------------------------------------------------------------------
dword __fastcall TDx_SoundNotify::FGetNumPositionNotifies()
{
return fNumPositionNotifies;
}
// --------------------------------------------------------------------------
// Property:    PositionNotifies
// Description: The PositionNotifies property is used internally to keep 
//              track of the TDSBPositionNotifies component most recently 
//              used by the TDx_SoundNotify::SetNotificationPositions() 
//              method; 
//              
//              This property is used internally but can be examined for 
//              external use. 
// --------------------------------------------------------------------------
TDSBPositionNotify* __fastcall TDx_SoundNotify::FGetPositionNotifies()
{
return fPositionNotifies;
}
// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDIRECTSOUNDNOTIFY interface used in the 
//              TDx_SoundNotify component and must be called before any 
//              methods of the TDx_SoundNotify component will function. 
// Params:      pSoundBuffer - 
//                The SoundBuffer parameter references the existing 
//                TDx_SoundBuffer or TDx_SoundCaptureBuffer component for which 
//                the TDx_SoundNotify component is to be created. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundNotify::Create( TComponent* pSoundBuffer )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created successfully." );
    return false;
    }

// check params for accuracy
if (pSoundBuffer==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pSoundBuffer' parameter must point to an existing TDx_SoundBuffer or TDx_SoundCaptureBuffer component and cannot be NULL." );
    return false;
    }

// the pSoundBuffer parameter can be either a TDx_SoundBuffer or a TDx_SoundCaptureBuffer component.
// check that this is the case.

AnsiString class_name = pSoundBuffer->ClassName();
if ((class_name!="TDx_SoundBuffer") &&
    (class_name!="TDx_SoundCaptureBuffer"))
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pSoundBuffer' parameter must point to an existing TDx_SoundBuffer or TDx_SoundCaptureBuffer component." );
    return false;
    }

// code that creates the internal IDirectSoundNotify interface
if (class_name=="TDx_SoundBuffer")
    {
    TDx_SoundBuffer* sound_buffer = (TDx_SoundBuffer*) pSoundBuffer;
    if (!sound_buffer->Created)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The TDx_SoundNotify cannot be created because the TDx_SoundBuffer component specified by the 'pSoundBuffer' parameter has not yet been created." );
        return false;
        }
    fErrorValue = sound_buffer->Internal_LPDIRECTSOUNDBUFFER->QueryInterface( IID_IDirectSoundNotify, (LPVOID*)&fLPDIRECTSOUNDNOTIFY);
    }
else
    {
    TDx_SoundCaptureBuffer* sound_buffer = (TDx_SoundCaptureBuffer*) pSoundBuffer;
    if (!sound_buffer->Created)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The TDx_SoundNotify cannot be created because the TDx_SoundCaptureBuffer component specified by the 'pSoundBuffer' parameter has not yet been created." );
        return false;
        }
    fErrorValue = sound_buffer->Internal_LPDIRECTSOUNDCAPTUREBUFFER->QueryInterface( IID_IDirectSoundNotify, (LPVOID*)&fLPDIRECTSOUNDNOTIFY);
    }

if (fErrorValue!=DS_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The "+Name+"::Create() method failed with error: "+TDx_Sound_Library_ErrorString(fErrorValue)+", "+TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);

return true;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDIRECTSOUNDNOTIFY interface used in the 
//              TDx_SoundNotify component and should be called when the 
//              internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundNotify::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// pause existing thread
if (TDx_SoundNotify_Thread) TDx_SoundNotify_Thread->Pause();

// cleanup notifications
if (fPositionNotifies)
    {
    for (dword i=0;i<fNumPositionNotifies;i++)
    	if (fPositionNotifies->EventNotify[i])
        	CloseHandle( fPositionNotifies->EventNotify[i] );
    fPositionNotifies = NULL;
    }

// destroy the internal interface
try {
    if (FOnDestroy) FOnDestroy(this);
    }
catch (...)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception has occurred within "+Name+"::OnDestroy()" );
    }

try {
    if (fLPDIRECTSOUNDNOTIFY!=NULL) fLPDIRECTSOUNDNOTIFY->Release();
    }
catch (...)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception has occurred within LPDIRECTSOUNDNOTIFY->Release(). Check that you are destroying all components in reverse order of creation." );
    }

// successful or unsuccessful destruction, continue regardless
fLPDIRECTSOUNDNOTIFY = NULL;
fCreated = false;

// remove from list
if (TDx_SoundNotify_ComponentList)
    if (TDx_SoundNotify_ComponentList->IndexOf(this)!=-1)
        TDx_SoundNotify_ComponentList->Delete(TDx_SoundNotify_ComponentList->IndexOf(this));

// restart the thread
if (TDx_SoundNotify_Thread)
    {
    TDx_SoundNotify_Thread->HandlesModified = true;
    TDx_SoundNotify_Thread->Restart();
    }

return true;
}

// --------------------------------------------------------------------------
// Method:      SetNotificationPositions()
// Description: The TDx_SoundNotify::SetNotificationPositions method will set 
//              the notification positions for triggering events when the 
//              play or read cursor reaches them. Before calling this method, 
//              make sure to setup the TDSBPositionNotify multiwrapper 
//              component with appropriate data. The positions specified in 
//              this call will supercede any previously set positions. The 
//              buffer must be stopped for this method to work. 
//              
//              Note: DirectSound seems to limit the number of notification 
//              positions that can be set on any individual buffer to 60. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DSERR_INVALIDPARAM 
//              DSERR_OUTOFMEMORY 
// Params:      pNumPositionNotifies - 
//                The NumPositionNotifies parameter defines the number of 
//                TDSBPositionNotify components referenced by the 
//                NumPositionNotifies parameter of this method. 
//              pPositionNotifies - 
//                The PositionNotifies parameter references a 
//                TDSBPositionNotify multiwrapper component which contains the 
//                notification positions offsets to be set for the buffer. 
//                Note: Do not set the TDSBPositionNotify::Event property when 
//                using this method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundNotify::SetNotificationPositions( dword pNumPositionNotifies, TDSBPositionNotify* pPositionNotifies )
{
// Original Function Definition
// HRESULT SetNotificationPositions(
//   DWORD cPositionNotifies,
//   LPCDSBPOSITIONNOTIFY lpcPositionNotifies
// );

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetNotificationPositions()", "TDX_NOTCREATED", "The "+Name+"::SetNotificationPositions() method was called before being created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pNumPositionNotifies > pPositionNotifies->ArraySize)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::SetNotificationPositions()", "TDX_BADPARAMS", "'pNumPositionNotifies' cannot be larger than "+pPositionNotifies->Name+"::ArraySize ["+IntToStr(pPositionNotifies->ArraySize)+"].");
    return false;
    }

// okay, use the parameters
fNumPositionNotifies = pNumPositionNotifies;
fPositionNotifies = pPositionNotifies;

// scan through the notifications and create a continuous trigger event for each
for (dword i=0;i<fNumPositionNotifies;i++)
    {
    if (fPositionNotifies->EventNotify[i]!=NULL)
        CloseHandle( fPositionNotifies->EventNotify[i] );

	fPositionNotifies->EventNotify[i] = CreateEvent( NULL, FALSE, FALSE, NULL );
    }

// pause existing thread
if (TDx_SoundNotify_Thread) TDx_SoundNotify_Thread->Pause();

// Call Original Function
if (fLPDIRECTSOUNDNOTIFY) fErrorValue = fLPDIRECTSOUNDNOTIFY->SetNotificationPositions( (DWORD) fNumPositionNotifies, (LPCDSBPOSITIONNOTIFY) fPositionNotifies->Internal_DSBPOSITIONNOTIFY_Ptr );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (TDx_SoundNotify_Thread)
    	{
        TDx_SoundNotify_Thread->HandlesModified = true;
        TDx_SoundNotify_Thread->Restart();
        }
    if (FOnError) FOnError( this, Name+"::SetNotificationPositions()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// everything worked ok, add to list
if (TDx_SoundNotify_ComponentList) TDx_SoundNotify_ComponentList->Add(this);

// restart the thread
if (TDx_SoundNotify_Thread)
    {
    TDx_SoundNotify_Thread->HandlesModified = true;
    TDx_SoundNotify_Thread->Restart();
    }

// Finished!
return true;
}

// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDIRECTSOUNDNOTIFY __fastcall TDx_SoundNotify::FGetInternal_LPDIRECTSOUNDNOTIFY()
{
return fLPDIRECTSOUNDNOTIFY;
}
// --------------------------------------------------------------------------
LPDIRECTSOUNDNOTIFY* __fastcall TDx_SoundNotify::FGetInternal_LPDIRECTSOUNDNOTIFY_Ptr()
{
return &fLPDIRECTSOUNDNOTIFY;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundNotify::FSetInternal_LPDIRECTSOUNDNOTIFY( LPDIRECTSOUNDNOTIFY pLPDIRECTSOUNDNOTIFY )
{
if (!fCreated)
    {
    fLPDIRECTSOUNDNOTIFY = pLPDIRECTSOUNDNOTIFY;
    fCreated = (fLPDIRECTSOUNDNOTIFY!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundNotify::Internal_LPDIRECTSOUNDNOTIFY_Update()
{
fCreated = (fLPDIRECTSOUNDNOTIFY!=NULL);
}

// --------------------------------------------------------------------------
